// HPRDH.h : Header file of the Dynamic Link Library HPRDH.DLL  
//

#ifdef HPRDH_EXPORTS
__declspec(dllexport) DWORD PrtOpenW (HANDLE *phPRT, LPWSTR lpPrinterName);
__declspec(dllexport) DWORD PrtOpenA (HANDLE *phPRT, LPSTR lpPrinterName);
__declspec(dllexport) DWORD PrtClose (HANDLE *hPRT);
__declspec(dllexport) DWORD PrtClaim (HANDLE hPRT, DWORD dwTimeout);
__declspec(dllexport) DWORD PrtRelease (HANDLE hPRT);
__declspec(dllexport) DWORD PrtWrite (HANDLE hPRT, LPBYTE pbWriteBuffer, DWORD dwLenWriteBuffer, LPDWORD pdwNoOfBytesWritten);
__declspec(dllexport) DWORD PrtRead (HANDLE hPRT, DWORD dwTimeout, DWORD *pdwType, 
                                     LPDWORD pdwParArray, LPDWORD pdwArraySize,
                                     LPBYTE pbReadData, LPDWORD pdwReadDataLen);
__declspec(dllexport) DWORD PrtIoCtlW (HANDLE hPRT, DWORD dwControlId, LPWSTR lpValue, 
                                       LPBYTE pbInBuffer, DWORD dwInLen,
                                       LPBYTE pbOutData,  LPDWORD pDwOutLen);
__declspec(dllexport) DWORD PrtIoCtlA (HANDLE hPRT, DWORD dwControlId, LPSTR lpValue, 
                                       LPBYTE pbInBuffer, DWORD dwInLen,
                                       LPBYTE pbOutData,  LPDWORD pDwOutLen);



#else

extern "C" __declspec(dllimport) DWORD PrtOpenW (HANDLE *phPRT, LPWSTR lpPrinterName);
extern "C" __declspec(dllimport) DWORD PrtOpenA (HANDLE *phPRT, LPSTR lpPrinterName);
extern "C" __declspec(dllimport) DWORD PrtClose (HANDLE *hPRT);
extern "C" __declspec(dllimport) DWORD PrtClaim (HANDLE hPRT, DWORD dwTimeout);
extern "C" __declspec(dllimport) DWORD PrtRelease (HANDLE hPRT);
extern "C" __declspec(dllimport) DWORD PrtWrite (HANDLE hPRT, LPBYTE pbWriteBuffer, DWORD dwLenWriteBuffer, LPDWORD pdwNoOfBytesWritten);
extern "C" __declspec(dllimport) DWORD PrtRead (HANDLE hPRT, DWORD dwTimeout, 
                                                DWORD *pdwType, 
                                                LPDWORD pdwParArray, 
                                                LPDWORD pdwArraySize,
                                                LPBYTE  pbReadData, 
                                                LPDWORD pdwReadDataLen);
extern "C" __declspec(dllexport) DWORD PrtIoCtlW (HANDLE hPRT, DWORD dwControlId, LPWSTR lpValue, 
                                                  LPBYTE pbInBuffer, DWORD dwInLen,
                                                  LPBYTE pbOutData,  LPDWORD pDwOutLen);
extern "C" __declspec(dllexport) DWORD PrtIoCtlA (HANDLE hPRT, DWORD dwControlId, LPSTR lpValue, 
                                                  LPBYTE pbInBuffer, DWORD dwInLen,
                                                  LPBYTE pbOutData,  LPDWORD pDwOutLen);
#endif

#ifdef UNICODE
#define PrtOpen  PrtOpenW
#define PrtIoCtl PrtIoCtlW
#else
#define PrtOpen  PrtOpenA
#define PrtIoCtl PrtIoCtlA
#endif // !UNICODE

// The following types of information available until now: 

    // The width of the document is returned from the printer
#define PRT_DOCUMENT_WIDTH              0x2274      //  ("\"t" )
    // The result of an MSR or MICR read is returned
#define PRT_MSR_MICR_READ_DATA          0x2272      //  ("\"r" )
    // The printer's response on an MSR write 
#define PRT_MSR_WRITE_STATUS            0x2372      //  ("#r")
    // Control point is reached
#define PRT_CONTROL_POINT               0x2174      // ("!t")
    // Control point 2 is reached
#define PRT_CONTROL_POINT_2             0x2974      // (")t")
    // The global printer status is returned
#define PRT_GLOBAL_STATUS               0x217A      // ( "!z")
    // The special printer message is returned
#define PRT_SPECIAL_MESSAGE             0x227A      // ( "\"z")
    // The printing unit parameters are returned
#define PRT_PRINTING_UNIT_PARAMETERS    0x237A      // ( "#z")  
    // Printer is ready for download
#define PRT_READY_TO_LOAD               0x4D4F44    //  ("MOD")
    // Printer is ready to load
#define PRT_READY_TO_LOAD_XE            0x6D6F64    //  ("mod")
    // Printer is ready to load
#define PRT_READY_TO_LOAD_FNT           0x464E54    //  ("FNT")
    // The printer returned the identifiers of all loadware
#define PRT_MOD_ID                      0x4944      // ("ID")
    // The load software is started
#define PRT_BEL_L                       0x074C      // ("BEL L")



#define PRT_INFINITE        INFINITE    // wait until success is reached
#define PRT_IMMEDIATELY     0           // return at once with or without success


// For customer errors bit 29 is set

#define PRT_NO_ERROR                ERROR_SUCCESS
#define PRT_OPEN_NOT_DONE           0x20000001 
#define PRT_CLAIM_NOT_DONE          0x20000002
#define PRT_COMMUNICATION_BROKEN    0x20000003 


#define USER_ERROR                  0x20000000  // Bit 29: User error    

 
